; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; Eins				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; TIMER				
	mov ssVT_L, EINS
	mov ssVT_H, NULL

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b0000100
	tst temp
	breq NEUSTART_MIT_WDR_s
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_s:
	rjmp NEUSTART_MIT_WDR_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D auf EINGANG														
PORTS_CLEAR:
	clr temp
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp	
	out PORTC,temp				
	out PORTD,temp				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_FEHLER:
	rjmp PROGRAMM_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)
	sbi (LED_A0_DDR),(LED_A0_PIN_NR)
	sbi (LED_A1_DDR),(LED_A1_PIN_NR)
	sbi (LED_A2_DDR),(LED_A2_PIN_NR)
	sbi (LED_A3_DDR),(LED_A3_PIN_NR)
	sbi (LED_A4_DDR),(LED_A4_PIN_NR)
	sbi (LED_A5_DDR),(LED_A5_PIN_NR)
	sbi (LED_A6_DDR),(LED_A6_PIN_NR)
	sbi (LED_A7_DDR),(LED_A7_PIN_NR)
	sbi (LED_A8_DDR),(LED_A8_PIN_NR)
	sbi (LED_A9_DDR),(LED_A9_PIN_NR)
;-------------------------------------------------------------------------------
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	LED_A0_OFF
	LED_A1_OFF
	LED_A2_OFF
	LED_A3_OFF
	LED_A4_OFF
	LED_A5_OFF
	LED_A6_OFF
	LED_A7_OFF
	LED_A8_OFF
	LED_A9_OFF
;-------------------------------------------------------------------------------
	LED_GRUEN_ON
	rcall WAIT_100ms
	LED_GRUEN_OFF
;-------------------------------------------------------------------------------
	LED_GELB_ON
	rcall WAIT_100ms
	LED_GELB_OFF
;-------------------------------------------------------------------------------
	LED_ROT_ON
	rcall WAIT_100ms
	LED_ROT_OFF
;-------------------------------------------------------------------------------
	LED_A0_ON
	rcall WAIT_100ms
	LED_A0_OFF

	LED_A1_ON
	rcall WAIT_100ms
	LED_A1_OFF

	LED_A2_ON
	rcall WAIT_100ms
	LED_A2_OFF

	LED_A3_ON
	rcall WAIT_100ms
	LED_A3_OFF

	LED_A4_ON
	rcall WAIT_100ms
	LED_A4_OFF

	LED_A5_ON
	rcall WAIT_100ms
	LED_A5_OFF

	LED_A6_ON
	rcall WAIT_100ms
	LED_A6_OFF

	LED_A7_ON
	rcall WAIT_100ms
	LED_A7_OFF

	LED_A8_ON
	rcall WAIT_100ms
	LED_A8_OFF

	LED_A9_ON
	rcall WAIT_100ms
	LED_A9_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
