;											
; Windmesser-LED							
; 09/2019									
; Bernhard.Erfurt@gmx.de					
;											

; Blinken die LEDs, das ist nicht gut !									
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf

; ATmega8 										
.include "m8def.inc"
.include "MACROS.asm"							; Macros
; KONSTANTEN									
.equ TAKT					=1000000	; 1 MHz	
; WINDMESSER									
.equ WIND_PIN_NR			= 5
.equ WIND_PIN				= PINC
.equ WIND_DDR				= DDRC
.equ WIND_PORT				= PORTC
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR		= 1
.equ LED_GRUEN_DDR			= DDRD
.equ LED_GRUEN_PORT			= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR		= 2
.equ LED_GELB_DDR			= DDRD
.equ LED_GELB_PORT			= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR			= 3
.equ LED_ROT_DDR			= DDRD
.equ LED_ROT_PORT			= PORTD


; REGISTER										
.def TIMERZAHL 		= R7
.def ROHDATA 		= R8
.def IMPULSE 		= R9
.def FREQUENZ 		= R10
.def FREQUENZ_MAX 	= R11

.def ssVT_L 	= R12
.def ssVT_H 	= R13

.def NULL		= R14
.def EINS		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=SRAM_START+0		; 0x0060 START Adresse 		
.equ adr_FREIGABE				=SRAM_START+10


.equ adr_SRAM_CHECK				=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp TIM2_OVF   		; Timer2 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;TIM1_OVF   	  	; Timer1 Overflow Handler           
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   		; Timer0 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	rcall WAIT_100ms
	rjmp INTERRUPT_ERROR
;Programm-Error										
PROGRAMM_ERROR:
	LED_ROT_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	rcall WAIT_100ms
	rjmp PROGRAMM_ERROR
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp

	rcall SRAM_CLEAR
	rcall REGISTER_CLEAR
	rcall PORTS_CLEAR
	rcall STARTWERTE
	rcall WDR_INITIALISIERUNG
	rcall LED_INITIALISIERUNG
	rcall WIND_INITIALISIEREN
	rcall TIMER2_INITIALISIEREN_ASYNCRON_1ms
	rcall TIMER_AKTIVIEREN
	rcall SLEEP_EXT_INTERRUPT_INITIALISIEREN
	sei			; Interrupts freigeben								
;-------------------------------------------------------------------
	rcall SLEEP_1s
	rcall WIND_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall SLEEP_1ms
;-------------------------------------------------------------------
	LDS temp,(adr_FREIGABE)
	tst temp
	breq LOOP
;-------------------------------------------------------------------
	STS(adr_FREIGABE),NULL
	rcall WIND_MAX_BERECHNUNG
	rcall WIND_LED
	rcall WIND_LED_MAX
	rcall PROGRAMM_CHECK
	tst FREQUENZ_MAX
	brne LOOP_LED
;-------------------------------------------------------------------
	LED_GRUEN_ON
	rcall SLEEP_5ms
	LED_GRUEN_OFF
	rjmp LOOP
;-------------------------------------------------------------------
LOOP_LED:
	rcall SLEEP_5ms		; LED-Blinken
	LED_A0_OFF
	LED_A1_OFF
	LED_A2_OFF
	LED_A3_OFF
	LED_A4_OFF
	LED_A5_OFF
	LED_A6_OFF
	LED_A7_OFF
	LED_A8_OFF
	LED_A9_OFF
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TIMER.asm"			; TIMER							
.include "WIND.asm"				; Windsensor					
.include "SONSTIGES.asm"		; sonstiges						
.include "WAIT.asm"				; 1 MHz							
.include "LED_V1.asm"			; LED							


